package xyz.tbvns.Generate;

import javafx.stage.Window;
import org.joml.Vector3d;
import org.joml.Vector4d;
import org.joml.Vector4f;
import xyz.tbvns.Constant;
import xyz.tbvns.GeometryDash.GDObject;
import xyz.tbvns.Object.Color;
import xyz.tbvns.Object.Face;
import xyz.tbvns.Object.Vector3;
import xyz.tbvns.Other.ZAxisComparator;
import xyz.tbvns.Utils;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

public class Generate3D {
    public void proceed() {
        if (Constant.isReady) {
            try {
                if (Constant.useKeyframe) {
                    //new Generate3D().GenerateAnimKeyframe();
                } else {
                    new Generate3D().GenerateAnimMove();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
    public void Generate() throws FileNotFoundException {
        List<Vector4f> points = new ReadOBJ().getPoints(Constant.obj);
        Constant.points3d = points;
        for (int i = 0; i < points.size(); i++) {
            Vector4f p = points.get(i);

            Vector3d p1 = new Vector3d(new double[]{p.x, p.z, p.y});
            Vector4d p2 = new Utils().projectPoint(p1);
            Constant.points3d.set(i, new Vector4f((float) p2.x, (float) p2.y, (float) p2.z, (float) p2.w));

            Constant.points.add(new Vector3((float) p2.x, (float) p2.y, (float) p2.z));

            GDObject.addBasic(725, (float) (p2.x + 1000), (float) (p2.y + 1000), i+1);
        }

        List<Face> faces = new ReadOBJ().getFace(Constant.obj);

        List<Color> colors = new ArrayList<>();

        Constant.faces = faces;
        final int[] id = {0};
        faces.forEach(f -> {
            if (!colors.contains(f.color)) {
                f.colorId = colors.size() + 1;
                colors.add(f.color);
            }

            id[0] +=1;
            if (f.points.size() == 3) {
                GDObject.addGradient(0f, 100f, 0, f.points.get(0), f.points.get(1), f.points.get(2), f.points.get(2), id[0], Math.round(Constant.points3d.get(f.points.get(0) - 1).z * 10000), f.colorId);
            } else {
                GDObject.addGradient(0f, 100f, 0, f.points.get(0), f.points.get(1), f.points.get(2), f.points.get(3), id[0], Math.round(Constant.points3d.get(f.points.get(0) - 1).z * 10000), f.colorId);
            }
        });


        for (int i = 0; i < colors.size(); i++) {
            Color c = colors.get(i);
            GDObject.addColor(0f, 200f, Math.round(c.red * 255), Math.round(c.green * 255), Math.round(c.blue * 255), i+1);
        }

        GDObject.send();

        Constant.points3d = new ArrayList<>();
        Constant.faces = new ArrayList<>();
        Constant.points = new ArrayList<>();
        GDObject.level = new ArrayList<>();
    }

    public void GenerateAnimKeyframe(Window window) {
        List<File> OBJs = new ArrayList<>();
        List<File> MTLs = new ArrayList<>();

        for (int i = 0; i < Constant.obj.listFiles().length; i++) {
            File f = Constant.obj.listFiles()[i];
            if (f.getAbsolutePath().endsWith(".obj")) {
                OBJs.add(f);
            }
        }

        for (int i = 0; i < Constant.mtl.listFiles().length; i++) {
            File f = Constant.mtl.listFiles()[i];
            if (f.getAbsolutePath().endsWith(".mtl")) {
                MTLs.add(f);
            }
        }

        if (Constant.obj.isDirectory()) {
            if (Constant.hasMTL && !Constant.mtl.isDirectory()) {
                return;
            }
            GDObject.addKeyframeTrigger();
            int counter = 0;
            boolean first = true;
            for (int i = 0; i < OBJs.size(); i++) {
                try {
                    if (counter >= Constant.skipFrame || first) {
                        counter = 0;

                        List<Vector4f> points = new ReadOBJ().getPoints(OBJs.get(i));
                        Constant.points3d = points;

                        for (int i2 = 0; i2 < points.size(); i2++) {
                            Vector4f p = points.get(i2);

                            Vector3d p1 = new Vector3d(new double[]{p.x, p.z, p.y});
                            Vector4d p2 = new Utils().projectPoint(p1);
                            Constant.points3d.set(i2, new Vector4f((float) p2.x, (float) p2.y, (float) p2.z, (float) p2.w));

                            Constant.points.add(new Vector3((float) p2.x, (float) p2.y, (float) p2.z));

                            if (i == 0) {
                                GDObject.addBasic(725, (float) (p2.x + 1000), (float) (p2.y + 1000), i2+1);
                                GDObject.addKeyframe((float) (p2.x + 1000), (float) (p2.y + 1000), i2+1, 1, i, 1/Constant.fps *(Constant.skipFrame +1));
                            } else {
                                GDObject.addKeyframe((float) (p2.x + 1000), (float) (p2.y + 1000), i2+1, 1, i, 1/Constant.fps *(Constant.skipFrame +1));
                            }
                        }

                        Constant.sortedPoints3d = points;
                        Constant.sortedPoints3d.sort(new ZAxisComparator());
                        Constant.sortedPoints3d = Constant.sortedPoints3d.reversed();

                        List<Face> faces = new ReadOBJ().getFaceAnimation(OBJs.get(i), MTLs.get(i));
                        List<Color> colors = new ArrayList<>();

                        Constant.faces = faces;
                        final int[] id = {0};
                        AtomicInteger temp = new AtomicInteger(i);

                        faces.forEach(f -> {
                            if (!colors.contains(f.color)) {
                                f.colorId = colors.size() + 1;
                                colors.add(f.color);
                            } else {
                                for (int i1 = 0; i1 < colors.size(); i1++) {
                                    Color color = colors.get(i1);
                                    if (color == f.color) {
                                        f.colorId = i1;
                                    }
                                }
                            }

                            id[0] +=1;
                            if (f.points.size() == 3) {
                                int index = Utils.getSortedIndex(Constant.points3d.get(f.points.get(0)));
                                GDObject.addGradient((temp.get()*(1/Constant.fps * Constant.gameSpeed)*30), 100f, 0, f.points.get(0), f.points.get(1), f.points.get(2), f.points.get(2), id[0], index, f.colorId);
                            } else {
                                int index = Utils.getSortedIndex(Constant.points3d.get(f.points.get(0)));
                                GDObject.addGradient((temp.get()*(1/Constant.fps * Constant.gameSpeed)*30), 100f, 0, f.points.get(0), f.points.get(1), f.points.get(2), f.points.get(3), id[0], index, f.colorId);
                            }
                        });


                        for (int i2 = 0; i2 < colors.size(); i2++) {
                            Color c = colors.get(i2);
                            GDObject.addColor(i*10f, 200f, Math.round(c.red * 255), Math.round(c.green * 255), Math.round(c.blue * 255), i2+1);
                        }

                        Constant.points3d = new ArrayList<>();
                        Constant.faces = new ArrayList<>();
                        Constant.points = new ArrayList<>();
                    } else {
                        counter+=1;
                    }
                    first = false;
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

            GDObject.export(window);

            GDObject.level = new ArrayList<>();
        }
    }

    public void GenerateAnimMove() throws FileNotFoundException {
        List<File> OBJs = new ArrayList<>();
        List<File> MTLs = new ArrayList<>();
        List<Vector4f> oldPoint = new ArrayList<>();

        for (int i = 0; i < Constant.obj.listFiles().length; i++) {
            File f = Constant.obj.listFiles()[i];
            if (f.getAbsolutePath().endsWith(".obj")) {
                OBJs.add(f);
            }
        }

        for (int i = 0; i < Constant.mtl.listFiles().length; i++) {
            File f = Constant.mtl.listFiles()[i];
            if (f.getAbsolutePath().endsWith(".mtl")) {
                MTLs.add(f);
            }
        }

        if (Constant.obj.isDirectory()) {
            if (Constant.hasMTL && !Constant.mtl.isDirectory()) {
                return;
            }
            for (int i = 0; i < OBJs.size(); i++) {
                List<Vector4f> points = new ReadOBJ().getPoints(OBJs.get(i));
                Constant.points3d = points;
                for (int i2 = 0; i2 < points.size(); i2++) {
                    Vector4f p = points.get(i2);

                    Vector3d p1 = new Vector3d(p.x, p.z, p.y);
                    Vector4d p2 = new Utils().projectPoint(p1);
                    Constant.points3d.set(i, new Vector4f((float) p2.x, (float) p2.y, (float) p2.z, (float) p2.w));

                    Constant.points.add(new Vector3((float) p2.x, (float) p2.y, (float) p2.z));

                    if (i == 0) {
                        GDObject.addBasic(725, (float) p2.x, (float) p2.y, i2+1);
                    } else {
                        Vector3d p1old = new Vector3d(oldPoint.get(i2).x, oldPoint.get(i2).z, oldPoint.get(i2).y);
                        Vector4d p2old = new Utils().projectPoint(p1old);

                        GDObject.addMove(i*10f, i2+1, (float) (p2old.x - p2.x), (float) (p2old.y - p2.y), 0f);
                    }
                }

                oldPoint = points;

                List<Face> faces = new ReadOBJ().getFaceAnimation(OBJs.get(i), MTLs.get(i));

                List<Color> colors = new ArrayList<>();

                Constant.faces = faces;
                final int[] id = {0};
                AtomicInteger temp = new AtomicInteger(i);

                faces.forEach(f -> {
                    if (!colors.contains(f.color)) {
                        f.colorId = colors.size() + 1;
                        colors.add(f.color);
                    }

                    id[0] +=1;
                    if (f.points.size() == 3) {
                        GDObject.addGradient(temp.get()*10f, 100f, 0, f.points.get(0), f.points.get(1), f.points.get(2), f.points.get(2), id[0], Math.round(Utils.getZ(f) * 10000), f.colorId);
                    } else {
                        GDObject.addGradient(temp.get()*10f, 100f, 0, f.points.get(0), f.points.get(1), f.points.get(2), f.points.get(3), id[0], Math.round(Utils.getZ(f) * 10000), f.colorId);
                    }
                });


                for (int i2 = 0; i2 < colors.size(); i2++) {
                    Color c = colors.get(i2);
                    GDObject.addColor(i*10f, 200f, Math.round(c.red * 255), Math.round(c.green * 255), Math.round(c.blue * 255), i2+1);
                }

                Constant.points3d = new ArrayList<>();
                Constant.faces = new ArrayList<>();
                Constant.points = new ArrayList<>();
            }

            GDObject.send();

            GDObject.level = new ArrayList<>();
        }

    }
}
