package xyz.tbvns.JavaFX;

import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;
import xyz.tbvns.Maths.BPM;
import xyz.tbvns.Utils;

public class FXBPMtoFPS {
    public static void show() {
        Stage stage = new Stage();

        stage.setTitle("BPM to FPS converter");
        stage.setResizable(false);
        stage.setMaxHeight(160);
        stage.setMinHeight(160);
        stage.setMaxWidth(100);
        stage.setMinWidth(100);

        Pane pane = new Pane();
        Scene scene = new Scene(pane, stage.getMaxWidth(), stage.getMaxHeight());
        scene.setRoot(pane);

        FlowPane flowPane = new FlowPane();
        flowPane.setPrefSize(scene.getWidth(), scene.getHeight());
        flowPane.alignmentProperty().set(Pos.TOP_LEFT);
        flowPane.setPadding(new Insets(5));

        flowPane.getChildren().add(new Label("BPM:"));
        TextField bpm = new TextField("80");
        bpm.setPrefWidth(scene.getWidth() - flowPane.getPadding().getBottom() * 2);
        bpm.textProperty().addListener((observableValue, s, t1) -> Utils.fixToNumber(bpm, s, t1));
        flowPane.getChildren().add(bpm);
        flowPane.getChildren().add(new Label("Beats per bar:"));
        TextField bpb = new TextField("4");
        bpb.textProperty().addListener((observableValue, s, t1) -> Utils.fixToNumber(bpb, s, t1));
        bpb.setPrefWidth(scene.getWidth() - flowPane.getPadding().getBottom() * 2);
        flowPane.getChildren().add(bpb);

        pane.getChildren().add(flowPane);

        Button button = new Button("Close");
        button.setMinWidth(60);
        button.setMaxWidth(60);
        button.setLayoutY(pane.getHeight() - button.getHeight() - 30);
        button.setLayoutX(pane.getWidth() / 2 - button.getMaxWidth() / 2);

        Button calc = new Button("Calculate");
        calc.setMinWidth(80);
        calc.setMaxWidth(80);
        calc.setLayoutY(pane.getHeight() - calc.getHeight() - 60);
        calc.setLayoutX(pane.getWidth() / 2 - calc.getMaxWidth() / 2);

        calc.setOnAction(actionEvent -> {
            try {
                int BPMint = Integer.parseInt(bpm.getText());
                int BPBint = Integer.parseInt(bpb.getText());

                BPM BPM = new BPM(BPMint, BPBint);

                String result =
                        "Best fps: " + BPM.toFPS() + "\n" +
                        "Minimal FPS: " + BPM.toMinimalFPS();

                FXWarning.info("BPM converter result", result, 300, 100);

            } catch (NumberFormatException e) {
                FXWarning.error("Error !", "Oops, something went wrong: \n" + e.getMessage(), 300, 100);
            }
        });

        button.setOnAction(actionEvent -> {
            stage.close();
        });

        pane.getChildren().add(button);
        pane.getChildren().add(calc);

        stage.setScene(scene);
        stage.show();
    }
}
