package xyz.tbvns.JavaFX;

import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;

public class FXWarning {
    public static void error(String title, String message, int width, int height) {
        Stage stage = new Stage();

        stage.setTitle(title);
        stage.setResizable(false);
        stage.setMaxHeight(height);
        stage.setMinHeight(height);
        stage.setMaxWidth(width);
        stage.setMinWidth(width);

        Pane pane = new Pane();
        Scene scene = new Scene(pane, width, height);
        scene.setRoot(pane);

        Image icon = new Image(FXWarning.class.getResourceAsStream("/WarnFX/error.png"), 50, 100, true, false);
        ImageView view = new ImageView(icon);
        view.setLayoutY(20);
        view.setLayoutX(20);

        Label label = new Label(message);
        label.setLayoutX(80);
        label.setLayoutY(20);

        Button button = new Button("Close");
        button.setMinWidth(60);
        button.setMaxWidth(60);
        button.setLayoutY(pane.getHeight() - button.getHeight() - 30);
        button.setLayoutX(pane.getWidth() / 2 - button.getMaxWidth() / 2);

        button.setOnAction(actionEvent -> {
            stage.close();
        });

        pane.getChildren().add(label);
        pane.getChildren().add(view);
        pane.getChildren().add(button);

        stage.setScene(scene);
        stage.show();
    }

    public static void info(String title, String message, int width, int height) {
        Stage stage = new Stage();

        stage.setTitle(title);
        stage.setResizable(false);
        stage.setMaxHeight(height);
        stage.setMinHeight(height);
        stage.setMaxWidth(width);
        stage.setMinWidth(width);

        Pane pane = new Pane();
        Scene scene = new Scene(pane, width, height);
        scene.setRoot(pane);

        Image icon = new Image(FXWarning.class.getResourceAsStream("/WarnFX/info.png"), 70, 100, true, false);
        ImageView view = new ImageView(icon);
        view.setLayoutY(7);
        view.setLayoutX(7);

        Label label = new Label(message);
        label.setLayoutX(80);
        label.setLayoutY(20);

        Button button = new Button("Close");
        button.setMinWidth(60);
        button.setMaxWidth(60);
        button.setLayoutY(pane.getHeight() - button.getHeight() - 30);
        button.setLayoutX(pane.getWidth() / 2 - button.getMaxWidth() / 2);

        button.setOnAction(actionEvent -> {
            stage.close();
        });

        pane.getChildren().add(label);
        pane.getChildren().add(view);
        pane.getChildren().add(button);

        stage.setScene(scene);
        stage.show();
    }
}
