package xyz.tbvns;


import javafx.scene.control.TextField;
import org.joml.*;
import org.locationtech.jts.geom.Coordinate;
import xyz.tbvns.Object.Face;
import xyz.tbvns.Object.Vector3;

import java.io.File;
import java.lang.Math;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;
import java.util.concurrent.atomic.AtomicReference;

public class Utils {
    public static int xScreenCenter = 320/2;
    public static int yScreenCenter = 240/2;
    public static Vector3d screenPosition = new Vector3d( 0, 0, 20 );
    public static Vector3d viewAngle = new Vector3d( 180, 180, 90);
    private static final double DEG_TO_RAD = 0.017453292;
    public static double modelScale = 20;

    public Vector4d projectPoint(Vector3d input) {
        Matrix4d matrix4d = new Matrix4d();
        matrix4d.perspective(Math.toRadians(2), 1, 0, -30);

        matrix4d.translate(new Vector3d(0, 0, 20));
        matrix4d.rotate(45, new Vector3d(1, 1, 0));

        Vector4d point = matrix4d.transform(new Vector4d(input.x, input.y, input.z, 1));

        point.x = (float) (point.x / point.w);
        point.y = (float) (point.y / point.w);
        point.z = (float) (point.z / point.w);

        return point;
    }

    private static float getFacez(Face face) {
        float facez;
        if (face.Has4Point) {
            facez = (Constant.points3d.get(face.points.get(0) -1).z + Constant.points3d.get(face.points.get(1) -1).z + Constant.points3d.get(face.points.get(2) -1).z + Constant.points3d.get(face.points.get(3) -1).z)/4;
        } else {
            facez = (Constant.points3d.get(face.points.get(0) -1).z + Constant.points3d.get(face.points.get(1) -1).z + Constant.points3d.get(face.points.get(2) -1).z)/3;
        }
        return facez;
    }

    public static float getZ(Face face) {
        //TODO: REDO ALL OF THIS WITH MY SAVIOUR "JOML" !
        //d = √[(x2 − x1)2 + (y2 − y1)2 + (z2 − z1)2]
        List<Vector4f> points = new ArrayList<>();
        face.points.forEach(p -> {
            Vector4f point = Constant.points3d.get(p - 1);
            points.add(point);
        });

        List<Double> dist = new ArrayList<>();

        points.forEach(p -> {
            dist.add((double) p.w);
        });

        double temp = 0;

        for (Double d : dist) {
            temp += d;
            System.out.println(temp + " -- temp");
        }

        temp = temp / dist.size();
        System.out.println(temp);

        return (float) temp;
    }

    public static List<File> sort(List<File> files) {
        HashMap<Integer, File> fileSorted = new HashMap<>();

        files.forEach(file -> {
            String name = file.getName();
            name = name.replaceAll("[^0-9]+", "");
            int id = Integer.parseInt(name);
            fileSorted.put(id, file);
        });

        List<File> fileReturned = new ArrayList<>();

        for (int i = 0; i < fileSorted.size(); i++) {
            try {
                if (fileSorted.get(i) != null) {
                    fileReturned.add(fileSorted.get(i));
                }
            } catch (Exception e) {
                //TODO: replace that code with some JavaFX

                //JFrame frame = new JFrame("Warning:");
                //JOptionPane.showMessageDialog(frame,
                //        "The frame " + i + " is missing !",
                //        "Warning !",
                //        JOptionPane.WARNING_MESSAGE);
            }
        }

        return fileReturned;
    }

    public static String fixToNumber(TextField textField, String s, String t1) {
        textField.setText(t1.replaceAll("(?![-+]?[0-9]*)", ""));
        if (t1.equalsIgnoreCase("-")) {
            return t1 + "0";
        }
        try {
            if (!t1.isBlank()) {
                Integer.parseInt(t1);
            }
        } catch (Exception e) {
            textField.setText(s);
            if (t1.equalsIgnoreCase("")) {
                textField.setText("");
            }
        }

        return textField.getText();
    }

    public static String fixToFloat(TextField textField, String s, String t1) {
        textField.setText(t1.replaceAll("(?![+-]?([0-9]+([.][0-9]*)?|[.][0-9]+))", ""));
        if (t1.equalsIgnoreCase("-") || t1.equalsIgnoreCase(".")) {
            return t1 + "0";
        }
        if (t1.endsWith(".")) {
            t1 = t1 + "0";
        }
        try {
            if (!t1.isBlank()) {
                Float.parseFloat(t1);
            }
        } catch (Exception e) {
            textField.setText(s);
            if (t1.equalsIgnoreCase("")) {
                textField.setText("");
            }
        }

        return textField.getText();
    }

    public static int safeParseInt(String str) {
        try {
            return Integer.parseInt(str);
        } catch (Exception e) {
            return 0;
        }
    }

    public static float safeParseFloat(String str) {
        try {
            return Float.parseFloat(str);
        } catch (Exception e) {
            return 0f;
        }
    }

    public static int getSortedIndex(Vector4f vec) {
        for (int i = 0; i < Constant.sortedPoints3d.size(); i++) {
            Vector4f tempVec = Constant.sortedPoints3d.get(i);
            if (tempVec == vec) {
                return i;
            }
        }
        return 0;
    }

}
